<meta charset="utf-8"/>

<script src="https://unpkg.com/vue@3/dist/vue.global.js"></script>
<script src="https://cdn.jsdelivr.net/npm/vuetify@3.1.12/dist/vuetify.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/vuetify@3.1.12/dist/vuetify-labs.min.js"></script>
<link href="https://cdn.jsdelivr.net/npm/vuetify@3.1.12/dist/vuetify.min.css" rel="stylesheet">
<link href="https://cdn.jsdelivr.net/npm/vuetify@3.1.12/dist/vuetify-labs.min.css" rel="stylesheet">
<link href="https://cdn.jsdelivr.net/npm/@mdi/font@5.x/css/materialdesignicons.min.css" rel="stylesheet">

<script type="text/x-template" id="app-template">
  <v-app>
    <div class="w-50 ma-auto text-h1 text-center">Книга рецептов</div>
    <v-data-table-server
      :headers="headers"
      :items="recipes"
      :items-per-page="itemsPerPage"
      :items-length="itemsLength"
      item-title="name"
      item-value="id"
      :loading="loading"
      :loading-text="loadingText"
      class="w-50 ma-auto"
      expand-on-click
      @update:options="loadItems"
      @click:row="loadItem"
    >
      <template v-slot:top>
        <v-dialog
          v-model="dialog"
          max-width="1000px"
        >
          <template v-slot:activator="{ props }">
            <v-btn
              color="primary"
              dark
              class="mb-2"
              v-bind="props"
            >
              Новый рецепт
            </v-btn>
          </template>

          <v-form ref="form">
            <v-card>
              <v-card-title>
                <span class="text-h5">Новый рецепт</span>
              </v-card-title>

              <v-card-text>
                <v-container>
                  <v-row>
                    <v-col
                      cols="12"
                    >
                      <v-text-field
                        v-model="editedRecipe.name"
                        :rules="[rules.required, rules.nameMaxLength]"
                        clearable
                        counter
                        label="Название"
                      ></v-text-field>
                    </v-col>
                    <v-col
                      cols="12"
                    >
                      <v-textarea
                        v-model="editedRecipe.description"
                        clearable
                        auto-grow
                        rows="4"
                        label="Описание"
                      ></v-textarea>
                    </v-col>
                    <v-col
                      cols="12"
                    >
                      <v-text-field
                        v-model="editedRecipe.cooking_time"
                        :rules="[rules.required]"
                        clearable
                        label="Время готовки в минутах"
                        suffix="мин."
                      ></v-text-field>
                    </v-col>
                    <v-col
                      cols="12"
                    >
                      <v-textarea
                        v-model="editedRecipe.ingredients"
                        :rules="[rules.required]"
                        clearable
                        auto-grow
                        rows="4"
                        label="Инредиенты (по одному на строку)"
                      ></v-textarea>
                    </v-col>
                  </v-row>
                </v-container>
              </v-card-text>

              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn
                  color="blue-darken-1"
                  variant="text"
                  @click="close"
                >
                  Отмена
                </v-btn>
                <v-btn
                  color="blue-darken-1"
                  variant="text"
                  @click="save"
                >
                  Добавить
                </v-btn>
              </v-card-actions>
            </v-card>
          </v-form>
        </v-dialog>
      </template>

      <template v-slot:item.name="{ item }">
        <span class="font-weight-bold">{{ item.title }}</span>
      </template>

      <template v-slot:expanded-row="{ item }">
        <div class="pa-5 text-body-1">Описание: {{ item.raw.description }}</div>
        <v-list disabled>
          <v-list-item
            v-for="(item, i) in item.raw.ingredients"
            :key="i"
            :value="item"
          >
            <template v-slot:prepend>
              <v-icon class="ma-3" icon="mdi-circle-medium"></v-icon>
            </template>

            <v-list-item-title v-text="item"></v-list-item-title>
          </v-list-item>
        </v-list>
      </template>
    </v-data-table-server>
  </v-app>
</script>

<div id="app"></div>

<script type="module">
  const { createApp } = Vue
  const { createVuetify } = Vuetify

  const vuetify = createVuetify()

  const app = createApp({
    template: '#app-template',
    data() {
      return {
        recipes: [],
        currentPage: 1,
        itemsPerPage: 10,
        itemsLength: 0,
        loadingText: 'Загрузка...',
        loading: true,
        headers: [
          {title: "Название", key: "name", sortable: false},
          {title: "Врем готовки в минутах", key: "cooking_time", sortable: false, align: "end"},
          {title: "Просмотров", key: "reviews", sortable: false, align: "end"},
        ],
        dialog: false,
        editedRecipe: {
          name: '',
          description: '',
          cooking_time: 1,
          ingredients: '',
        },
        emptyRecipe: {
          name: '',
          description: '',
          cooking_time: 1,
          ingredients: '',
        },
        rules: {
          required: value => !!value || 'Обязательное поле',
          nameMaxLength: value => value.length <= 200 || 'Длина должна быть меньше 200 символов',
        },
      }
    },

    async created () {
      await this.loadItems({page: 1, itemsPerPage: this.itemsPerPage})
    },

    watch: {
      dialog (val) {
        val || this.close()
      },
    },

    methods: {
      async loadItems ({page = 1, itemsPerPage = 10}) {
        this.loading = true
        this.currentPage = page

        if (itemsPerPage === -1) {
          // max for size
          itemsPerPage = 100
        }

        const response = await fetch(`http://${location.hostname}:5000/api/v1/recipes?page=${page}&size=${itemsPerPage}`)
        const data = await response.json()

        let {items, total} = data

        this.loading = false
        this.recipes = items
        this.itemsLength = total
      },

      async loadItem (e, item) {
        console.log(item.item.value)
        let recipe = this.recipes.find(r => r.id == item.item.raw.id)
        recipe.expanded = (recipe.expanded === null || recipe.expanded === undefined || !recipe.expanded)

        if (recipe.expanded) {
          const response = await fetch(`http://${location.hostname}:5000/api/v1/recipes/${recipe.id}`)
          const data = await response.json()

          recipe.reviews = data.reviews
        }
      },

      close () {
        this.dialog = false
        this.$nextTick(() => {
          this.editedRecipe = Object.assign({}, this.emptyRecipe)
        })
      },

      async save () {
        let validation = await this.$refs.form.validate()

        if (validation.valid) {
          this.editedRecipe.ingredients = this.editedRecipe.ingredients
                                          .split(/\r?\n/)
                                          .filter(item => item.toString() !== "")
                                          .map(item => item.trim())

          await fetch(`http://${location.hostname}:5000/api/v1/recipes`, {
            method: "POST",
            headers: {
              "Content-Type": "application/json",
              "Origin": location.host,
            },
            body: JSON.stringify(this.editedRecipe)
          })

          this.loadItems({page: this.currentPage, itemsPerPage: this.itemsPerPage})
          this.close()
        }
      },
    }
  })
  app.use(vuetify).mount('#app')
</script>
